﻿// <snippetJQueryRESTDataOperations.Functions>
/// <reference path="jquery1.4.1vsdoc.js" />

var $ptm = new $ptmC();

function $ptmC() {

    var temp = new $ptmCHelper();
}

function GetGlobalContextInternal() {
    try {
        if (typeof (GetGlobalContext) != "undefined")
            return GetGlobalContext();
        else {
            if (typeof (Xrm) != "undefined")
                return Xrm.Page.context;
            else
                return window.top.Xrm.Page.context;
        }
    }
    catch (ex) {

        if (typeof (Xrm) != "undefined")
            return Xrm.Page.context;
        else
            return window.top.Xrm.Page.context;
    }
}

$ptmC.prototype.context = null; 
$ptmC.prototype.serverUrl = null; 
$ptmC.prototype.tmpOrgName = null;
$ptmC.prototype.isIfdConnected = false;
$ptmC.prototype.isOutlook = false;
$ptmC.prototype.clientType = null;

$ptmC.prototype.browserIsIE = false;
$ptmC.prototype.iEVersion = -1;
$ptmC.prototype.iEDocumentMode = -1;


$ptmC.prototype.InitScript = function (inContext) {

    if (!(inContext)) {

        try {
            if (!($ptmC.prototype.context)) {
                $ptmC.prototype.context = GetGlobalContextInternal();
                $ptmC.prototype.serverUrl = $ptmC.prototype.context.getClientUrl();
                $ptmC.prototype.tmpOrgName = $ptmC.prototype.context.getOrgUniqueName();
                $ptmC.prototype.clientType = $ptmC.prototype.context.client.getClient();

                if ($ptmC.prototype.clientType == "Outlook")
                    $ptmC.prototype.isOutlook = true;
            }
        }
        catch (e) {
        }
    }
    else {
        try {
            $ptmC.prototype.context = inContext.getContext();
            $ptmC.prototype.serverUrl = $ptmC.prototype.context.getClientUrl();
            $ptmC.prototype.tmpOrgName = $ptmC.prototype.context.getOrgUniqueName();
            $ptmC.prototype.clientType = $ptmC.prototype.context.client.getClient();

            if ($ptmC.prototype.clientType == "Outlook")
                $ptmC.prototype.isOutlook = true;
        }
        catch (e) {
        }
    }

    try {
        try {
            if (!$ptmC.prototype.serverUrl.endsWith('/' + $ptmC.prototype.tmpOrgName))
                $ptmC.prototype.isIfdConnected = true;
        }
        catch (e) {
            if (!$ptmC.prototype.endsWith($ptmC.prototype.serverUrl, '/' + $ptmC.prototype.tmpOrgName))
                $ptmC.prototype.isIfdConnected = true;
        }
    }
    catch (e) { }

    $ptmC.prototype.ReadOutBrowserInfo();
}

//---------------------------------String Tools START----------------------
$ptmC.prototype.endsWith = function (instring, suffix) {
    var l = instring.length - suffix.length;
    return l >= 0 && instring.indexOf(suffix, l) === l;
}
//---------------------------------String Tools START----------------------

$ptmC.prototype.ReadOutBrowserInfo = function ReadOutBrowserInfo() {

    if (window.navigator.appName == "Microsoft Internet Explorer") {
        $ptmC.prototype.browserIsIE = true;

        var browserVersion = window.navigator.appVersion;
        browserVersion = browserVersion.substring(browserVersion.indexOf("MSIE") + 4);
        $ptmC.prototype.iEVersion = parseInt(browserVersion.substring(0, browserVersion.indexOf(".")));

        try {
            $ptmC.prototype.iEDocumentMode = document.documentMode;
        }
        catch (ex) { }
    }
}

//------------------------
$ptm.InitScript();
//-----------------------

//GetGlobalContext function exists in ClientGlobalContext.js.aspx so the
//host HTML page must have a reference to ClientGlobalContext.js.aspx.

//The XRM OData end-point
$ptmC.prototype.ODATA_ENDPOINT = "/XRMServices/2011/OrganizationData.svc";

$ptmC.prototype.createRecord = function (entityObject, odataSetName, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     Create a new record
    ///</summary>
    /// <param name="entityObject" type="Object" required="true">
    ///1: entity - a loose-type object representing an OData entity. any fields
    ///                 on this object must be camel-cased and named exactly as they 
    ///                 appear in entity metadata
    ///</param>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>

    //entityObject is required
    if (!entityObject) {
        alert("entityObject is required.");
        return;
    }
    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Parse the entity object into JSON
    var jsonEntity = window.JSON.stringify(entityObject);

    //Asynchronous AJAX function to Create a CRM record using OData
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        url: $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName,
        data: jsonEntity,
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.             
            XMLHttpRequest.setRequestHeader("Accept", "application/json");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            if (successCallback) {
                successCallback(data.d, textStatus, XmlHttpRequest);
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.retrieveRecord = function (id, odataSetName, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     retrieve an existing record
    ///</summary>
    /// <param name="id" type="guid" required="true">
    ///1: id -     the guid (primarykey) of the record to be retrieved
    ///</param>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>

    //id is required
    if (!id) {
        alert("record id is required.");
        return;
    }
    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Asynchronous AJAX function to Retrieve a CRM record using OData
    $.ajax({
        type: "GET",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        url: $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName + "(guid'" + id + "')",
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.             
            XMLHttpRequest.setRequestHeader("Accept", "application/json");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            if (successCallback) {
                successCallback(data.d, textStatus, XmlHttpRequest);
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.retrieveMultiple = function (odataSetName, filter, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     Retrieve multiple records
    ///</summary>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="filter" type="string">
    ///1: filter - a string representing the filter that is appended to the odatasetname
    ///                 of the OData URI.     
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>

    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Build the URI
    var odataUri = $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName + "()";


    //If a filter is supplied, append it to the OData URI
    if (filter) {
        odataUri += filter;
    }

    // alert('odatauri: ' + odataUri);

    //Asynchronous AJAX function to Retrieve CRM records using OData
    $.ajax({
        type: "GET",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        url: odataUri,
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.             
            XMLHttpRequest.setRequestHeader("Accept", "application/json");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            if (successCallback) {
                if (data && data.d && data.d.results) {
                    successCallback(data.d.results, textStatus, XmlHttpRequest);
                }
                else if (data && data.d) {
                    successCallback(data.d, textStatus, XmlHttpRequest);
                }
                else {
                    successCallback(data, textStatus, XmlHttpRequest);
                }
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.retrieveRecordFiltered = function (odataSetName, id, filter, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     Retrieve multiple records
    ///</summary>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="filter" type="string">
    ///1: filter - a string representing the filter that is appended to the odatasetname
    ///                 of the OData URI.     
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>

    //id is required
    if (!id) {
        alert("record id is required.");
        return;
    }

    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Build the URI
    var odataUri = $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName + "(guid'" + id + "')";


    //If a filter is supplied, append it to the OData URI
    if (filter) {
        odataUri += filter;
    }

    // alert('odatauri: ' + odataUri);

    //Asynchronous AJAX function to Retrieve CRM records using OData
    $.ajax({
        type: "GET",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        url: odataUri,
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.             
            XMLHttpRequest.setRequestHeader("Accept", "application/json");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            if (successCallback) {
                if (data && data.d && data.d.results) {
                    successCallback(data.d.results, textStatus, XmlHttpRequest);
                }
                else if (data && data.d) {
                    successCallback(data.d, textStatus, XmlHttpRequest);
                }
                else {
                    successCallback(data, textStatus, XmlHttpRequest);
                }
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.updateRecord = function (id, entityObject, odataSetName, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     update an existing record
    ///</summary>
    /// <param name="id" type="guid" required="true">
    ///1: id -     the guid (primarykey) of the record to be retrieved
    ///</param>
    /// <param name="entityObject" type="Object" required="true">
    ///1: entity - a loose-type object representing an OData entity. any fields
    ///                 on this object must be camel-cased and named exactly as they 
    ///                 appear in entity metadata
    ///</param>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>


    //id is required
    if (!id) {
        alert("record id is required.");
        return;
    }
    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Parse the entity object into JSON
    var jsonEntity = window.JSON.stringify(entityObject);

    //Asynchronous AJAX function to Update a CRM record using OData
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        data: jsonEntity,
        url: $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName + "(guid'" + id + "')",
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.             
            XMLHttpRequest.setRequestHeader("Accept", "application/json");

            //Specify the HTTP method MERGE to update just the changes you are submitting.             
            XMLHttpRequest.setRequestHeader("X-HTTP-Method", "MERGE");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            //The MERGE does not return any data at all, so we'll add the id 
            //onto the data object so it can be leveraged in a Callback. When data 
            //is used in the callback function, the field will be named generically, "id"
            data = new Object();
            data.id = id;
            if (successCallback) {
                successCallback(data, textStatus, XmlHttpRequest);
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.deleteRecord = function (id, odataSetName, successCallback, errorCallback) {
    ///<summary>
    ///Uses jQuery's AJAX object to call the Microsoft Dynamics CRM OData endpoint to
    ///     delete an existing record
    ///</summary>
    /// <param name="id" type="guid" required="true">
    ///1: id -     the guid (primarykey) of the record to be retrieved
    ///</param>
    /// <param name="odataSetName" type="string" required="true">
    ///1: set -    a string representing an OData Set. OData provides uri access
    ///                 to any CRM entity collection. examples: AccountSet, ContactSet,
    ///                 OpportunitySet. 
    ///</param>
    /// <param name="successCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon success
    ///                 of the ajax invocation.
    ///</param>
    /// <param name="errorCallback" type="function" >
    ///1: callback-a function that can be supplied as a callback upon error
    ///                 of the ajax invocation.
    ///</param>


    //id is required
    if (!id) {
        alert("record id is required.");
        return;
    }
    //odataSetName is required, i.e. "AccountSet"
    if (!odataSetName) {
        alert("odataSetName is required.");
        return;
    }

    //Asynchronous AJAX function to Delete a CRM record using OData
    $.ajax({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        datatype: "json",
        url: $ptmC.prototype.serverUrl + $ptmC.prototype.ODATA_ENDPOINT + "/" + odataSetName + "(guid'" + id + "')",
        beforeSend: function (XMLHttpRequest) {
            //Specifying this header ensures that the results will be returned as JSON.                 
            XMLHttpRequest.setRequestHeader("Accept", "application/json");

            //Specify the HTTP method DELETE to perform a delete operation.                 
            XMLHttpRequest.setRequestHeader("X-HTTP-Method", "DELETE");
        },
        success: function (data, textStatus, XmlHttpRequest) {
            if (successCallback) {
                successCallback(data.d, textStatus, XmlHttpRequest);
            }
        },
        error: function (XmlHttpRequest, textStatus, errorThrown) {
            if (errorCallback)
                errorCallback(XmlHttpRequest, textStatus, errorThrown);
            else
                $ptmC.prototype.errorHandler(XmlHttpRequest, textStatus, errorThrown);
        }
    });
}

$ptmC.prototype.errorHandler = function (xmlHttpRequest, textStatus, errorThrow) {
    ///<summary>
    ///A function that will display the error results of an AJAX operation
    ///</summary>
    alert("Error : " + textStatus + ": " + xmlHttpRequest.statusText);
}

//---------------------Fetch XML START-----------------------

function $ptmCHelper() {
}

$ptmCHelper.prototype.ptm_XMLHTTPSUCCESS = 200;
$ptmCHelper.prototype.ptm_XMLHTTPREADY = 4;


$ptmCHelper.prototype._ExecuteRequest = function (sXml, sMessage, fInternalCallback, fUserCallback) {
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open("POST", $ptmC.prototype.serverUrl + "/XRMServices/2011/Organization.svc/web", (fUserCallback != null));
    xmlhttp.setRequestHeader("Accept", "application/xml, text/xml, */*");
    xmlhttp.setRequestHeader("Content-Type", "text/xml; charset=utf-8");
    xmlhttp.setRequestHeader("SOAPAction", "http://schemas.microsoft.com/xrm/2011/Contracts/Services/IOrganizationService/Execute");

    if (fUserCallback != null) {
        //asynchronous: register callback function, then send the request.
        var crmServiceObject = this;
        xmlhttp.onreadystatechange = function () {
            fInternalCallback.call(crmServiceObject, xmlhttp, fUserCallback)
        };
        xmlhttp.send(sXml);
    } else {
        //synchronous: send request, then call the callback function directly
        xmlhttp.send(sXml);
        return fInternalCallback.call(this, xmlhttp, null);
    }
}

$ptmCHelper.prototype._HandleErrors = function (xmlhttp) {
    /// <summary>(private) Handles xmlhttp errors</summary>
    if (xmlhttp.status != $ptmCHelper.prototype.ptm_XMLHTTPSUCCESS) {
        var sError = "Error: " + xmlhttp.responseText + " " + xmlhttp.statusText;

        var indexOfPrvRead = xmlhttp.responseText.toLowerCase().indexOf("prvread");

        if (indexOfPrvRead > -1) {

            sError = "You don't have the required privilege for this product!\nPlease ensure that the \"mscrm-addons general security role\" is assigned to your user or contact your administrator.";
        }

        alert(sError);
        return true;

    } else {
        return false;
    }
}

$ptmCHelper.prototype._FetchCallback = function (xmlhttp, callback) {
    ///<summary>(private) Fetch message callback.</summary>
    //xmlhttp must be completed


    if (xmlhttp.readyState != $ptmCHelper.prototype.ptm_XMLHTTPREADY) {
        return;
    }

    //check for server errors
    if ($ptmCHelper.prototype._HandleErrors(xmlhttp)) {
        return;
    }

    var tempMoreRecord = xmlhttp.responseXML.getElementsByTagName("a:MoreRecords");
    var moreRecord = "false";
    if (tempMoreRecord.length == 0) {
        tempMoreRecord = xmlhttp.responseXML.getElementsByTagName("MoreRecords");

        if (tempMoreRecord.length != 0) {

            moreRecord = $(tempMoreRecord[0]).text();

        }
    }
    else {
        try {
            moreRecord = $(tempMoreRecord[0]).text();
        }
        catch (ex)
            { }
    }

    var tempPagingCookie = xmlhttp.responseXML.getElementsByTagName("a:PagingCookie");
    var pagingCookie = "false";
    if (tempPagingCookie.length == 0) {
        tempPagingCookie = xmlhttp.responseXML.getElementsByTagName("PagingCookie");

        if (tempPagingCookie.length != 0) {
            pagingCookie = $('<div/>').text($(tempPagingCookie[0].childNodes[0]).text()).html().replace(/"/g, '&quot;');
        }
    }
    else {
        pagingCookie = $('<div/>').text($(tempPagingCookie[0].childNodes[0]).text()).html().replace(/"/g, '&quot;');
    }

    var tempEntities = xmlhttp.responseXML.getElementsByTagName("a:Entities");
    if (tempEntities.length == 0) {

        tempEntities = xmlhttp.responseXML.getElementsByTagName("Entities");

        if (tempEntities.length != 0) {
            sFetchResult = tempEntities[0];
        }

    }
    else {
        sFetchResult = tempEntities[0];
    }


    if (sFetchResult) {
        //sFetchResult = sFetchResult.xml;
    }
    else {

        tempEntities = xmlhttp.responseXML.getElementsByTagName("a:Results");
        if (tempEntities.length == 0) {

            tempEntities = xmlhttp.responseXML.getElementsByTagName("Results");

            if (tempEntities.length != 0)
                sFetchResult = tempEntities[0];
            else
                sFetchResult = tempEntities;

        }
        else {
            sFetchResult = tempEntities[0];
        }

        if (sFetchResult)
            return sFetchResult.text;
    }

    resultDoc = sFetchResult;


    //parse result xml into array of jsDynamicEntity objects
    var results = new Array(resultDoc.childNodes.length);
    for (var i = 0; i < resultDoc.childNodes.length; i++) {
        var oResultNode = resultDoc.childNodes[i];
        var jDE = new $ptmC_jsDynamicEntity();
        jDE.moreRecords = moreRecord;
        jDE.pagingCookie = pagingCookie;
        var obj = new Object();

        for (var j = 0; j < oResultNode.childNodes.length; j++) {
            var baseElementName = oResultNode.childNodes[j].nodeName;

            if (typeof baseElementName == "undefined")
                baseElementName = oResultNode.childNodes[j].baseName;

            baseElementName = baseElementName.replace("a:", "");

            switch (baseElementName) {
                case "Attributes":
                    var attr = oResultNode.childNodes[j];

                    for (var k = 0; k < attr.childNodes.length; k++) {

                        // Establish the Key for the Attribute                        
                        var sKey = $(attr.childNodes[k].firstChild).text();
                        var sType = "";

                        // Determine the Type of Attribute value we should expect
                        for (var l = 0; l < attr.childNodes[k].childNodes[1].attributes.length; l++) {

                            if ($(attr.childNodes[k].childNodes[1].attributes[l])[0].nodeName == 'i:type') {
                                sType = $(attr.childNodes[k].childNodes[1].attributes[l])[0].nodeValue;

                                if (sType.indexOf(":") == 1)
                                    sType = sType.substring(2);

                                break;
                            }
                        }

                        switch (sType) {
                            case "OptionSetValue":
                                var entOSV = new $ptmC_jsOptionSetValue();
                                entOSV.type = sType;
                                entOSV.value = $(attr.childNodes[k].childNodes[1]).text();
                                obj[sKey] = entOSV;
                                break;

                            case "EntityReference":
                                var entRef = new $ptmC_jsEntityReference();
                                entRef.type = sType;
                                entRef.guid = $(attr.childNodes[k].childNodes[1].childNodes[0]).text();
                                entRef.logicalName = $(attr.childNodes[k].childNodes[1].childNodes[1]).text();
                                entRef.name = $(attr.childNodes[k].childNodes[1].childNodes[2]).text();
                                obj[sKey] = entRef;
                                break;

                            case "AliasedValue":
                                var entCV = new $ptmC_jsAliasedValue();
                                entCV.type = sType;
                                entCV.attrLogicalName = $(attr.childNodes[k].childNodes[1].childNodes[0]).text();
                                entCV.logicalName = $(attr.childNodes[k].childNodes[1].childNodes[1]).text();
                                entCV.value = $(attr.childNodes[k].childNodes[1].childNodes[2]).text();
                                obj[sKey] = entCV;
                                break;

                            default:
                                var entCV = new $ptmC_jsCrmValue();
                                entCV.type = sType;
                                entCV.value = $(attr.childNodes[k].childNodes[1]).text();
                                obj[sKey] = entCV;
                                break;
                        }
                    }

                    jDE.attributes = obj;
                    break;

                case "Id":
                    jDE.guid = $(oResultNode.childNodes[j]).text();
                    break;

                case "LogicalName":
                    jDE.logicalName = $(oResultNode.childNodes[j]).text();
                    break;

                case "FormattedValues":
                    var foVal = oResultNode.childNodes[j];

                    for (var k = 0; k < foVal.childNodes.length; k++) {
                        // Establish the Key, we are going to fill in the formatted value of the already found attribute
                        var sKey = $(foVal.childNodes[k].firstChild).text();

                        jDE.attributes[sKey].formattedValue = $(foVal.childNodes[k].childNodes[1]).text();

                    }
                    break;
            }
        }

        results[i] = jDE;
    }

    //return entities
    if (callback != null) callback(results);
    else return results;
}

$ptmC.prototype.Fetch = function (sFetchXml, fCallback) {
    /// <summary>Execute a FetchXml request. (result is the response XML)</summary>
    /// <param name="sFetchXml">fetchxml string</param>
    /// <param name="fCallback" optional="true" type="function">(Optional) Async callback function if specified. If left null, function is synchronous </param>
    var request = "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">";
    request += "<s:Body>";

    request += '<Execute xmlns="http://schemas.microsoft.com/xrm/2011/Contracts/Services">' + '<request i:type="b:RetrieveMultipleRequest" ' + ' xmlns:b="http://schemas.microsoft.com/xrm/2011/Contracts" ' + ' xmlns:i="http://www.w3.org/2001/XMLSchema-instance">' + '<b:Parameters xmlns:c="http://schemas.datacontract.org/2004/07/System.Collections.Generic">' + '<b:KeyValuePairOfstringanyType>' + '<c:key>Query</c:key>' + '<c:value i:type="b:FetchExpression">' + '<b:Query>';

    request += CrmEncodeDecode.CrmXmlEncode(sFetchXml);

    request += '</b:Query>' + '</c:value>' + '</b:KeyValuePairOfstringanyType>' + '</b:Parameters>' + '<b:RequestId i:nil="true"/>' + '<b:RequestName>RetrieveMultiple</b:RequestName>' + '</request>' + '</Execute>';

    request += '</s:Body></s:Envelope>';

    return $ptmCHelper.prototype._ExecuteRequest(request, "Fetch", $ptmCHelper.prototype._FetchCallback, fCallback);
}

function $ptmC_jsDynamicEntity(gID, sLogicalName, sMoreRecords, sPagingCookie) {
    this.moreRecords = sMoreRecords;
    this.pagingCookie = sPagingCookie;
    this.guid = gID;
    this.logicalName = sLogicalName;
    this.attributes = new Object();
}

function $ptmC_jsCrmValue(sType, sValue) {
    this.type = sType;
    this.value = sValue;
}

function $ptmC_jsEntityReference(gID, sLogicalName, sName) {
    this.guid = gID;
    this.logicalName = sLogicalName;
    this.name = sName;
    this.type = 'EntityReference';
}

function $ptmC_jsAliasedValue(sAttrLogicalName, sLogicalName, sValue) {
    this.attrLogicalName = sAttrLogicalName;
    this.logicalName = sLogicalName;
    this.value = sValue;
    this.type = 'EntityReference';
}

function $ptmC_jsOptionSetValue(iValue, sFormattedValue) {
    this.value = iValue;
    this.formattedValue = sFormattedValue;
    this.type = 'OptionSetValue';
}

//---------------------Fetch XML END-----------------------

//---------------------other START------------------------

$ptmC.prototype.showObject = function (name, obj) {
    alert(name + " = " + $ptmC.prototype.formatObject(obj))
}

$ptmC.prototype.formatObject = function (obj) {
    var arr = [];
    $.each(obj, function (key, val) {
        var next = key + ": ";
        next += $.isPlainObject(val) ? formatObject(val) : val; arr.push(next);
    });
    return "{\n " + arr.join(",\n ") + "\n}";
}

//---------------------other END------------------------

//---------------------------------Encoding START-------------------------------------

$ptmC.prototype.Base64 = {

    // private property
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode: function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = $ptmC.prototype.Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                                               this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                                               this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },


    // public method for decoding
    decode: function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = $ptmC.prototype.Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode: function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

//---------------------------------Encoding END-------------------------------------

//---------------------------------CRM Rollup Start -------------------------------------

$ptmC.prototype.IsRU8OrNewer = function () {

    var requestMain = ""
    requestMain += "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">";
    requestMain += "  <s:Body>";
    requestMain += "    <Execute xmlns=\"http://schemas.microsoft.com/xrm/2011/Contracts/Services\" xmlns:i=\"http://www.w3.org/2001/XMLSchema-instance\">";
    requestMain += "      <request i:type=\"b:RetrieveVersionRequest\" xmlns:a=\"http://schemas.microsoft.com/xrm/2011/Contracts\" xmlns:b=\"http://schemas.microsoft.com/crm/2011/Contracts\">";
    requestMain += "        <a:Parameters xmlns:c=\"http://schemas.datacontract.org/2004/07/System.Collections.Generic\" />";
    requestMain += "        <a:RequestId i:nil=\"true\" />";
    requestMain += "        <a:RequestName>RetrieveVersion</a:RequestName>";
    requestMain += "      </request>";
    requestMain += "    </Execute>";
    requestMain += "  </s:Body>";
    requestMain += "</s:Envelope>";

    try {
        //        var versionInfo = $ptmCHelper.prototype._ExecuteRequest(requestMain, "Execute", $ptmCHelper.prototype._FetchCallback).split(".");
        //
        //        if (parseInt(versionInfo[2]) >= 9690)  // rollup 7 or higher
        //            if (parseInt(versionInfo[3]) > 2730) // rollup 8 or higher
        //                return true;
    }
    catch (ex)
    { }
    return false;
}

//---------------------------------CRM Rollup END -------------------------------------

//---------------------------------CRM IsPolaris START-------------------------------------

$ptmC.prototype.IsRUPolaris = function (callback) {

    if (typeof ($ptmC.prototype.IsRUPolaris.IsPolaris) == "undefined") {

        var tempAppVersion = null;

        try {
            if ((typeof (APPLICATION_FULL_VERSION) != "undefined") && (APPLICATION_FULL_VERSION != null))
                tempAppVersion = APPLICATION_FULL_VERSION;
            else
                tempAppVersion = window.top.APPLICATION_FULL_VERSION;
        }
        catch (ex) { }


        if ((typeof (tempAppVersion) != "undefined") && (tempAppVersion != null) && (tempAppVersion != "")) {

            $ptmC.prototype.IsRUPolaris.statusText = "success";
            $ptmCHelper.prototype.IsRUPolarisProcessing(tempAppVersion, callback, $ptmC.prototype.IsRUPolaris.statusText);
        }
        else {

            var requestMain = "";
            requestMain += "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">";
            requestMain += "  <s:Body>";
            requestMain += "    <Execute xmlns=\"http://schemas.microsoft.com/xrm/2011/Contracts/Services\" xmlns:i=\"http://www.w3.org/2001/XMLSchema-instance\">";
            requestMain += "      <request i:type=\"b:RetrieveVersionRequest\" xmlns:a=\"http://schemas.microsoft.com/xrm/2011/Contracts\" xmlns:b=\"http://schemas.microsoft.com/crm/2011/Contracts\">";
            requestMain += "        <a:Parameters xmlns:c=\"http://schemas.datacontract.org/2004/07/System.Collections.Generic\" />";
            requestMain += "        <a:RequestId i:nil=\"true\" />";
            requestMain += "        <a:RequestName>RetrieveVersion</a:RequestName>";
            requestMain += "      </request>";
            requestMain += "    </Execute>";
            requestMain += "  </s:Body>";
            requestMain += "</s:Envelope>";


            $ptmC.prototype.IsRUPolaris.IsPolaris = $ptmCHelper.prototype._ExecuteRequest(requestMain, "Execute", $ptmCHelper.prototype.IsRUPolarisCallback, callback);
        }
    }
    else {

        if (callback != null)
            callback($ptmC.prototype.IsRUPolaris.IsPolaris, $ptmC.prototype.IsRUPolaris.statusText);
    }

    if (callback == null)
        return $ptmC.prototype.IsRUPolaris.IsPolaris;
}

$ptmCHelper.prototype.IsRUPolarisProcessing = function (versionString, userCallback, statusText) {

    var retValue = null;

    try {

        var versionArray = new Array();
        var i = 0;

        while (versionString.indexOf(".") >= 0) {

            var tempIndex = versionString.indexOf(".");

            versionArray[i] = versionString.substring(0, tempIndex);
            versionString = versionString.substring(tempIndex + 1);
            i++;
        }
        versionArray[i] = versionString;


        if ((versionArray[2] > 9690) || ((versionArray[2] == 9690) && (versionArray[3] > 3101)))
            retValue = true;
        else
            retValue = false;
    }
    catch (ex)
        { }

    $ptmC.prototype.IsRUPolaris.IsPolaris = retValue;

    if (userCallback != null)
        userCallback(retValue, statusText);
    else
        return retValue;
}

$ptmCHelper.prototype.IsRUPolarisCallback = function (crmServiceObject, userCallback) {
    if (crmServiceObject.readyState != $ptmCHelper.prototype.ptm_XMLHTTPREADY) {
        return;
    }

    //check for server errors
    if ($ptmCHelper.prototype._HandleErrors(crmServiceObject)) {

        return;
    }

    var retValue = null;
    var resString = "";

    if (crmServiceObject != null && crmServiceObject.responseXML != null) {

        var tempExecuteRes = crmServiceObject.responseXML.getElementsByTagName("ExecuteResult");

        if (tempExecuteRes != null && tempExecuteRes[0] != null) {

            var tempResults = tempExecuteRes[0].getElementsByTagName("a:Results");

            if (tempResults.length == 0)
                tempResults = tempExecuteRes[0].getElementsByTagName("Results");


            if (tempResults != null && tempResults[0] != null) {

                var res = tempExecuteRes[0].getElementsByTagName("c:value");

                if (res.length == 0)
                    res = tempExecuteRes[0].getElementsByTagName("value");

                if (res != null && res[0] != null) {


                    if (typeof (res[0].nodeTypedValue) != "undefined")
                        resString = res[0].nodeTypedValue;
                    else
                        resString = res[0].textContent;

                }
            }
        }
    }


    if (crmServiceObject.status == 200)
        $ptmC.prototype.IsRUPolaris.statusText = "success";
    else
        $ptmC.prototype.IsRUPolaris.statusText = "error";

    retValue = $ptmCHelper.prototype.IsRUPolarisProcessing(resString, userCallback, $ptmC.prototype.IsRUPolaris.statusText);

    if (userCallback == null)
        return retValue;
}

//---------------------------------CRM IsPolaris END-------------------------------------

//---------------------------------SetStateRequest START-------------------------------

$ptmC.prototype.SetStateRequest = function (entityId, entityTypeName, statecode, statuscode) {

    var requestMain = ""
    requestMain += "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">";
    requestMain += "  <s:Body>";
    requestMain += "    <Execute xmlns=\"http://schemas.microsoft.com/xrm/2011/Contracts/Services\" xmlns:i=\"http://www.w3.org/2001/XMLSchema-instance\">";
    requestMain += "      <request i:type=\"b:SetStateRequest\" xmlns:a=\"http://schemas.microsoft.com/xrm/2011/Contracts\" xmlns:b=\"http://schemas.microsoft.com/crm/2011/Contracts\">";
    requestMain += "        <a:Parameters xmlns:c=\"http://schemas.datacontract.org/2004/07/System.Collections.Generic\">";
    requestMain += "          <a:KeyValuePairOfstringanyType>";
    requestMain += "            <c:key>EntityMoniker</c:key>";
    requestMain += "            <c:value i:type=\"a:EntityReference\">";
    requestMain += "              <a:Id>" + entityId + "</a:Id>";
    requestMain += "              <a:LogicalName>" + entityTypeName + "</a:LogicalName>";
    requestMain += "              <a:Name i:nil=\"true\" />";
    requestMain += "            </c:value>";
    requestMain += "          </a:KeyValuePairOfstringanyType>";
    requestMain += "          <a:KeyValuePairOfstringanyType>";
    requestMain += "            <c:key>State</c:key>";
    requestMain += "            <c:value i:type=\"a:OptionSetValue\">";
    requestMain += "              <a:Value>" + statecode + "</a:Value>";
    requestMain += "            </c:value>";
    requestMain += "          </a:KeyValuePairOfstringanyType>";
    requestMain += "          <a:KeyValuePairOfstringanyType>";
    requestMain += "            <c:key>Status</c:key>";
    requestMain += "            <c:value i:type=\"a:OptionSetValue\">";
    requestMain += "              <a:Value>" + statuscode + "</a:Value>";
    requestMain += "            </c:value>";
    requestMain += "          </a:KeyValuePairOfstringanyType>";
    requestMain += "        </a:Parameters>";
    requestMain += "        <a:RequestId i:nil=\"true\" />";
    requestMain += "        <a:RequestName>SetState</a:RequestName>";
    requestMain += "      </request>";
    requestMain += "    </Execute>";
    requestMain += "  </s:Body>";
    requestMain += "</s:Envelope>";


    $ptmCHelper.prototype._ExecuteRequest(requestMain, "Execute", $ptmCHelper.prototype.SetStateCallback);
}

$ptmCHelper.prototype.SetStateCallback = function (crmServiceObject, xmlhttp) {
    if (crmServiceObject.readyState != $ptmCHelper.prototype.ptm_XMLHTTPREADY) {
        return;
    }

    //check for server errors
    if ($ptmCHelper.prototype._HandleErrors(crmServiceObject)) {
        return;
    }
}

//---------------------------------SetStateRequest END-------------------------------

//---------------------------------TriggerWorkflowRequest START----------------------

$ptmC.prototype.TriggerWorkflow = function (inEntityId, inWorkflowId, userCallback) {

    var requestMain = "";
    requestMain += "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">";
    requestMain += "  <s:Body>";
    requestMain += "    <Execute xmlns=\"http://schemas.microsoft.com/xrm/2011/Contracts/Services\" xmlns:i=\"http://www.w3.org/2001/XMLSchema-instance\">";
    requestMain += "      <request i:type=\"b:ExecuteWorkflowRequest\" xmlns:a=\"http://schemas.microsoft.com/xrm/2011/Contracts\" xmlns:b=\"http://schemas.microsoft.com/crm/2011/Contracts\">";
    requestMain += "        <a:Parameters xmlns:c=\"http://schemas.datacontract.org/2004/07/System.Collections.Generic\">";
    requestMain += "          <a:KeyValuePairOfstringanyType>";
    requestMain += "            <c:key>EntityId</c:key>";
    requestMain += "            <c:value i:type=\"d:guid\" xmlns:d=\"http://schemas.microsoft.com/2003/10/Serialization/\">" + inEntityId + "</c:value>";
    requestMain += "          </a:KeyValuePairOfstringanyType>";
    requestMain += "          <a:KeyValuePairOfstringanyType>";
    requestMain += "            <c:key>WorkflowId</c:key>";
    requestMain += "            <c:value i:type=\"d:guid\" xmlns:d=\"http://schemas.microsoft.com/2003/10/Serialization/\">" + inWorkflowId + "</c:value>";
    requestMain += "          </a:KeyValuePairOfstringanyType>";
    requestMain += "        </a:Parameters>";
    requestMain += "        <a:RequestId i:nil=\"true\" />";
    requestMain += "        <a:RequestName>ExecuteWorkflow</a:RequestName>";
    requestMain += "      </request>";
    requestMain += "    </Execute>";
    requestMain += "  </s:Body>";
    requestMain += "</s:Envelope>";


    return $ptmCHelper.prototype._ExecuteRequest(requestMain, "Execute", $ptmCHelper.prototype.StartWorkflowCallback, userCallback);
}

$ptmCHelper.prototype.StartWorkflowCallback = function (crmServiceObject, userCallback) {
    if (crmServiceObject.readyState != $ptmCHelper.prototype.ptm_XMLHTTPREADY) {
        return;
    }

    //check for server errors
    if ($ptmCHelper.prototype._HandleErrors(crmServiceObject)) {

        return;
    }

    var retValue = "";

    if (crmServiceObject != null && crmServiceObject.responseXML != null) {

        var tempExecuteRes = crmServiceObject.responseXML.getElementsByTagName("ExecuteResult");

        if (tempExecuteRes != null && tempExecuteRes[0] != null) {

            var tempResults = tempExecuteRes[0].getElementsByTagName("a:Results");

            if (tempResults.length == 0)
                tempResults = tempExecuteRes[0].getElementsByTagName("Results");


            if (tempResults != null && tempResults[0] != null) {

                var res = tempExecuteRes[0].getElementsByTagName("c:value");

                if (res.length == 0)
                    res = tempExecuteRes[0].getElementsByTagName("value");

                if (res != null && res[0] != null) {

                    if ($ptmC.prototype.browserIsIE && $ptmC.prototype.iEVersion < 10)
                        retValue = res[0].nodeTypedValue;
                    else
                        retValue = res[0].textContent;
                }
            }
        }
    }


    var statusText = "";

    if (crmServiceObject.status == 200)
        statusText = "success";
    else
        statusText = "error";


    if (userCallback != null)

        userCallback(retValue, statusText);

    else
        return retValue;

}

//---------------------------------TriggerWorkflowRequest END----------------------

//---------------------------------GetBinaryFile START-------------------------------

$ptmC.prototype.GetBinaryFile = function (strURL, fnCallback, activityMimeAttachmentId, vbsFileName, userId, password, bBypassCache) {
    /// <summary>Get the content of a binary file from an url</summary>
    /// <param name="strURL" type="URL">URL of the file which shall be fetched</param>
    /// <param name="fnCallback" type="functionName">Callbackfunction which shall be called when file was loaded, has one parameter which contains information and the content of the file</param>
    /// <param name="activityMimeAttachmentId" type="activityMimeAttachmentId">[Optional]ActivityMimeAttachmentId which has been changed, objResponse.ActivityMimeAttachmentId will contain it</param>
    /// <param name="vbsFileName" type="vbsFileName">[Recommended]absolute vbsFileName, needed for binaryFileFetching at IE environment, be sure you added the vbs to a webresource</param>
    /// <param name="userId" type="username">[Optional]Username which shall be used</param>
    /// <param name="password" type="password">[Optional]Password which shall be used</param>
    /// <param name="bBypassCache" type="bBypassCache">[Optional]bBypassCache</param>

    /*
    * This is the vbsFile which is needed for this function
    * add it as a WebResource and use the parameter vbsFileName
    * to use the IE-Hack
    */

    /*
    * Start - vbsScript
    */

    //        <!-- IEBinaryToArray_ByteStr -->
    //        Function IEBinaryToArray_ByteStr(Binary)
    //    	    IEBinaryToArray_ByteStr = CStr(Binary)
    //    	    End Function
    //        Function IEBinaryToArray_ByteStr_Last(Binary)
    //    	    Dim lastIndex
    //    	    lastIndex = LenB(Binary)
    //    	    if lastIndex mod 2 Then
    //    	    IEBinaryToArray_ByteStr_Last = Chr( AscB( MidB( Binary, lastIndex, 1 ) ) )
    //    	    Else
    //    	    IEBinaryToArray_ByteStr_Last = " + '""' + "
    //    	    End If
    //        End Function

    /*
    * END - vbsScript
    */

    var XMLHttp = null;
    var XMLHttpStateChanged = function () {
        if (XMLHttp.readyState == 4) {
            var objResponse = {};

            if (XMLHttp.status == "12007") {
                alert("Error 12007: Couldnt resolve URL: " + strURL);
            }

            else if (XMLHttp.status == "404") {
                alert("Error 404: File doesn't exist - " + strURL);
            }

            else if (XMLHttp.status == "304" || XMLHttp.status == "200" ||
				XMLHttp.status == "206" || XMLHttp.status == "0") {


                var IE_HACK = (/msie/i.test(navigator.userAgent) && !/opera/i.test(navigator.userAgent));
                if (vbsFileName == undefined)
                    IE_HACK = false;
                if (IE_HACK) {
                    var fileref = document.createElement('script');
                    fileref.setAttribute("type", "text/vbscript");
                    fileref.setAttribute("src", vbsFileName);
                    fileref.onreadystatechange = function (fileref) {
                        if (this.readyState == 'complete' || this.readyState == 'loaded') {
                            //convert binary with VBScript
                            //needed at IE

                            //faster, but needs more RAM
                            //injected with loading "ptm_vbscript_injection"
                            //                            var convertResponseBodyToText = function (binary) {
                            //                                return IEBinaryToArray_ByteStr(binary).replace(/[\s\S]/g, function (t) {
                            //                                    var v = t.charCodeAt(0);
                            //                                    return String.fromCharCode(v & 0xff, v >> 8);
                            //                                }) + IEBinaryToArray_ByteStr_Last(binary);
                            //                            }

                            //slower, but needs less RAM
                            if (convertResponseBodyToText == undefined) {
                                var convertResponseBodyToText = function (IEByteArray) {

                                    var ByteMapping = {};
                                    for (var i = 0; i < 256; i++) {
                                        for (var j = 0; j < 256; j++) {
                                            ByteMapping[String.fromCharCode(i + j * 256)] =
                            			String.fromCharCode(i) + String.fromCharCode(j);
                                        }
                                    }

                                    var rawBytes = IEBinaryToArray_ByteStr(IEByteArray);


                                    var lastChr = IEBinaryToArray_ByteStr_Last(IEByteArray);
                                    return rawBytes.replace(/[\s\S]/g,

                            	function (match) { return ByteMapping[match]; }) + lastChr;
                                }
                            }

                            var fileContent = convertResponseBodyToText(XMLHttp.responseBody);

                            if (typeof (CollectGarbage) == "function")
                                CollectGarbage();

                            objResponse.Content = fileContent;
                            objResponse.HTTPStatus =
					            XMLHttp.status;
                            objResponse.ContentLength =
					            XMLHttp.getResponseHeader("Content-Length");
                            objResponse.ContentType =
					            XMLHttp.getResponseHeader("Content-Type");
                            objResponse.File = strURL;
                            if (activityMimeAttachmentId != undefined)
                                objResponse.ActivityMimeAttachmentId = activityMimeAttachmentId;
                            XMLHttp = null;

                            fnCallback(objResponse);
                        }
                    }
                    document.getElementsByTagName("head")[0].appendChild(fileref);
                }
                else {
                    /*****************************************************************************
                    *
                    *This maybe work for other browsers except IE
                    * but at IE you have to convert the file with this VBScript above
                    * Isnt tested yet because there isnt crossbrowsersupport for CRM atm.
                    *
                    ******************************************************************************/
                    typeof XMLHttp.responseBody == 'unknown' ?
                            XMLHttp.responseBody :
                            XMLHttp.responseText;
                    objResponse.HTTPStatus =
					            XMLHttp.status;
                    objResponse.ContentLength =
					            XMLHttp.getResponseHeader("Content-Length");
                    objResponse.ContentType =
					            XMLHttp.getResponseHeader("Content-Type");
                    objResponse.File = strURL;
                    if (activityMimeAttachmentId != undefined)
                        objResponse.ActivityMimeAttachmentId = activityMimeAttachmentId;
                    XMLHttp = null;
                    fnCallback(objResponse);
                }


            }

        }
    }
    XMLHttpStateChanged.activityMimeAttachmentId = activityMimeAttachmentId;

    if (window.XMLHttpRequest) {
        XMLHttp = new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        try {
            XMLHttp = new ActiveXObject('MSXML2.XMLHttp.3.0');
        } catch (ex) {
            XMLHttp = null;
        }
    }

    if (XMLHttp) {
        if (fnCallback) {
            if (typeof (XMLHttp.onload) != 'undefined') {
                XMLHttp.onload = XMLHttpStateChanged;
            } else {
                XMLHttp.onreadystatechange = XMLHttpStateChanged;
            }
        }

        var openErrorThrown = false;
        if (userId == undefined || password == undefined) {
            //Without authentication
            try {
                XMLHttp.open("GET", strURL, true);
            }
            catch (ex) {
                openErrorThrown = true;
                alert("Error at fetching data from: " + strURL + "without authentication\r\n\r\n" +
                      ex.message + "\r\n" +
                      "Be sure you configured security options to allow cross-domain datatransfer");
            }
        }
        else {
            //With authentication
            try {
                XMLHttp.open("GET", strURL, true, userId, password);
            }
            catch (ex) {
                openErrorThrown = true;
                alert("Error at fetching data from: " + strURL + "with authentication\r\n\r\n" +
                      ex.message + "\r\n" +
                      "Be sure you entered correct username and password \r\n" +
                      "Be sure you configured security options to allow cross-domain datatransfer");
            }
        }

        if (!openErrorThrown) {
            if (XMLHttp.overrideMimeType)
                XMLHttp.overrideMimeType('text/plain; charset=x-user-defined');

            if (typeof (bBypassCache) != 'undefined') {
                if (bBypassCache == true)
                    XMLHttp.setRequestHeader(
					'If-Modified-Since',
					'Sat, 1 Jan 1970 00:00:00 GMT'
				);
            }

            XMLHttp.send(null);
        }
    } else {
        if (fnCallback) fnCallback();
    }
}

//---------------------------------GetBinaryFile END-------------------------------

//---------------------------------BinaryEncodeBase64 START-------------------------------

$ptmC.prototype.BinaryEncodeBase64 = function (input) {
    /// <summary>Encodes to base64, using binary data</summary>
    /// <param name="input" type="input">Input which shall be encoded with base64</param>
    /// <returns type="base64String">Returns a base64String</returns>
    var keyStr = "ABCDEFGHIJKLMNOP" +
                "QRSTUVWXYZabcdef" +
                "ghijklmnopqrstuv" +
                "wxyz0123456789+/" +
                "=";

    var output = "";
    var chr1, chr2, chr3 = "";
    var enc1, enc2, enc3, enc4 = "";
    var i = 0;
    var outputArray = new Array();

    do {
        chr1 = input.charCodeAt(i++);
        chr2 = input.charCodeAt(i++);
        chr3 = input.charCodeAt(i++);

        enc1 = chr1 >> 2;
        enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
        enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
        enc4 = chr3 & 63;

        if (isNaN(chr2)) {
            enc3 = enc4 = 64;
        } else if (isNaN(chr3)) {
            enc4 = 64;
        }

        outputArray.push(keyStr.charAt(enc1));
        outputArray.push(keyStr.charAt(enc2));
        outputArray.push(keyStr.charAt(enc3));
        outputArray.push(keyStr.charAt(enc4));

        chr1 = chr2 = chr3 = "";
        enc1 = enc2 = enc3 = enc4 = "";
    } while (i < input.length);

    output = outputArray.join("");

    delete outputArray;

    if (typeof (CollectGarbage) == "function")
        CollectGarbage();

    return output;
}

//---------------------------------BinaryEncodeBase64 END-------------------------------

////---------------------------------BinaryUrlDecodeBase64 START-------------------------------

$ptmC.prototype.BinaryUrlDecodeBase64 = function (input) {
    /// <summary>Decodes Attachment.URL (generated by Attachment Extractor) from base64</summary>
    /// <param name="input" type="input">Input which shall be decoded from base64</param>
    /// <returns type="string">Returns the decoded string</returns>
    var keyStr = "ABCDEFGHIJKLMNOP" +
                "QRSTUVWXYZabcdef" +
                "ghijklmnopqrstuv" +
                "wxyz0123456789+/" +
                "=";

    var output = new Array();
    var chr1, chr2, chr3 = "";
    var enc1, enc2, enc3, enc4 = "";
    var i = 0;

    // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
    var base64test = /[^A-Za-z0-9\+\/\=]/g;
    if (base64test.exec(input)) {
        alert("There were invalid base64 characters in the input text.\n" +
               "Valid base64 characters are A-Z, a-z, 0-9, ´+´, ´/´, and ´=´\n" +
               "Expect errors in decoding.");
    }
    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");


    do {
        enc1 = keyStr.indexOf(input.charAt(i++));

        enc2 = keyStr.indexOf(input.charAt(i++));

        enc3 = keyStr.indexOf(input.charAt(i++));

        enc4 = keyStr.indexOf(input.charAt(i++));

        chr1 = (enc1 << 2) | (enc2 >> 4);
        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
        chr3 = ((enc3 & 3) << 6) | enc4;

        var tmp = String.fromCharCode(chr1);
        if (tmp != '')
            output.push(tmp);

        var tmp = String.fromCharCode(chr2);
        if (enc3 != 64 && tmp != '') {

            output.push(tmp);
        }

        var tmp = String.fromCharCode(chr3);
        if (enc4 != 64 && tmp != '') {

            output.push(tmp);
        }

        chr1 = chr2 = chr3 = "";
        enc1 = enc2 = enc3 = enc4 = "";

    } while (i < input.length);

    var outputString = "";

    for (var i = 0; i < output.length; i = i + 2) {
        outputString += output[i];
    }

    delete output;

    if (typeof (CollectGarbage) == "function")
        CollectGarbage();

    return outputString;
}

///---------------------------------BinaryUrlDecodeBase64 END-------------------------------

//---------------------------------BrowserDetectionController START-------------------------

$ptmC.prototype.BrowserDetectionController = new function () {

    this.GetBrowserName = function () {
        if ($ptmCHelper.prototype.BDCH.privateBrowserName != null && $ptmCHelper.prototype.BDCH.privateBrowserName != "" && typeof $ptmCHelper.prototype.BDCH.privateBrowserName != "undefined") {
            return $ptmCHelper.prototype.BDCH.privateBrowserName;
        }
        else {
            $ptmCHelper.prototype.BDCH.DetectBrowser();
            if ($ptmCHelper.prototype.BDCH.privateBrowserName == null && $ptmCHelper.prototype.BDCH.privateBrowserName == "" && typeof $ptmCHelper.prototype.BDCH.privateBrowserName == "undefined") {
                alert("Browser Detection Problem [Detection of BrowserName];" + "value: " + $ptmCHelper.prototype.BDCH.privateBrowserName);
            }
            return $ptmCHelper.prototype.BDCH.privateBrowserName;
        }
    };

    this.GetBrowserVersion = function () {
        if ($ptmCHelper.prototype.BDCH.privateBrowserVersion != null && $ptmCHelper.prototype.BDCH.privateBrowserVersion != "" && typeof $ptmCHelper.prototype.BDCH.privateBrowserVersion != "undefined") {
            return $ptmCHelper.prototype.BDCH.privateBrowserVersion;
        }
        else {
            $ptmCHelper.prototype.BDCH.DetectBrowser();
            if ($ptmCHelper.prototype.BDCH.privateBrowserVersion == null && $ptmCHelper.prototype.BDCH.privateBrowserVersion == "" && typeof $ptmCHelper.prototype.BDCH.privateBrowserVersion == "undefined") {
                alert("Browser Detection Problem [Detection of BrowserVersion];" + "value: " + $ptmCHelper.prototype.BDCH.privateBrowserVersion);
            }
            return $ptmCHelper.prototype.BDCH.privateBrowserVersion;
        }
    };

}


$ptmCHelper.prototype.BDCH = new Object();
$ptmCHelper.prototype.BDCH.privateBrowserName = "";
$ptmCHelper.prototype.BDCH.privateBrowserVersion = null;
$ptmCHelper.prototype.BDCH.position = null;
$ptmCHelper.prototype.BDCH.end = null;

$ptmCHelper.prototype.BDCH.DetectBrowser = function () {
    if (navigator.userAgent.search("MSIE") >= 0) {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "MSInternetExplorer";

        $ptmCHelper.prototype.BDCH.position = navigator.userAgent.search("MSIE") + 5;
        $ptmCHelper.prototype.BDCH.end = navigator.userAgent.search("; Windows");
        $ptmCHelper.prototype.BDCH.privateBrowserVersion = parseFloat(navigator.userAgent.substring($ptmCHelper.prototype.BDCH.position, $ptmCHelper.prototype.BDCH.end));
    }
    else if (navigator.userAgent.search("Chrome") >= 0) {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "GoogleChrome";

        $ptmCHelper.prototype.BDCH.position = navigator.userAgent.search("Chrome") + 7;
        $ptmCHelper.prototype.BDCH.end = navigator.userAgent.search(" Safari");
        $ptmCHelper.prototype.BDCH.privateBrowserVersion = parseFloat(navigator.userAgent.substring($ptmCHelper.prototype.BDCH.position, $ptmCHelper.prototype.BDCH.end));
    }
    else if (navigator.userAgent.search("Firefox") >= 0) {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "MozillaFirefox";

        $ptmCHelper.prototype.BDCH.position = navigator.userAgent.search("Firefox") + 8;
        $ptmCHelper.prototype.BDCH.privateBrowserVersion = parseFloat(navigator.userAgent.substring($ptmCHelper.prototype.BDCH.position));
    }
    else if (navigator.userAgent.search("Safari") >= 0 && navigator.userAgent.search("Chrome") < 0) {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "AppleSafari";

        $ptmCHelper.prototype.BDCH.position = navigator.userAgent.search("Version") + 8;
        $ptmCHelper.prototype.BDCH.end = navigator.userAgent.search(" Safari");
        $ptmCHelper.prototype.BDCH.privateBrowserVersion = parseFloat(navigator.userAgent.substring($ptmCHelper.prototype.BDCH.position, $ptmCHelper.prototype.BDCH.end));
    }
    else if (navigator.userAgent.search("Opera") >= 0) {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "Opera";

        $ptmCHelper.prototype.BDCH.position = navigator.userAgent.search("Version") + 8;
        $ptmCHelper.prototype.BDCH.privateBrowserVersion = parseFloat(navigator.userAgent.substring($ptmCHelper.prototype.BDCH.position));
    }
    else // other browser
    {
        $ptmCHelper.prototype.BDCH.privateBrowserName = "OtherBrowser";
    }
}

//---------------------------------BrowserDetectionController END-------------------------